<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="status === 'audit' || status === 'taskFormDetail'"
				 label-width="160px" @submit.native.prevent>
			<el-divider content-position="left"><i class="el-icon-document"></i>
				<span style="color: red;border-top: 20px">*</span>用车项目
				<el-button style="margin-left: 20px" type="primary" :readonly="true" :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" @click="insertEvent('base')"  plain>
					新增
				</el-button>
			</el-divider>
			<el-row  :gutter="15">
				<el-col :span="24">
					<vxe-table
						border
						show-overflow
						show-footer
						ref="baseTable"
						:key="baseKey"
						class="vxe-table-element"
						:data="inputForm.projectList"
						style="margin-left: 5em"
						@cell-click=""
						@edit-closed=""
						keep-source
						:readonly="true"
						highlight-current-row
						:edit-config="{trigger: 'click', mode: 'cell', showStatus: true, autoClear: true, icon: '-'}"
					>
						<vxe-table-column field="name" align="center" title="项目名称" :edit-render="{}" show-overflow="title">
							<template v-slot:edit="scope">
								<el-input  :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" @focus="openProgramPageForm(scope.$rowIndex)" placeholder="请填写项目名称" :readonly="true" v-model="scope.row.name"/>
							</template>
						</vxe-table-column>
						<vxe-table-column field="no" align="center" title="项目编号" :edit-render="{}">
							<template v-slot:edit="scope">
								<el-input :disabled="true" :readonly="true" placeholder="请填写项目编号" v-model="scope.row.no"/>
							</template>
						</vxe-table-column>
						<vxe-table-column  field="leader" align="center" title="项目负责人" :edit-render="{}">
							<template v-slot:edit="scope">
								<el-input :disabled="true" placeholder="请填写项目负责人" v-model="scope.row.leader"/>
							</template>
						</vxe-table-column>
						<vxe-table-column field="createTime" align="center" title="创建时间" :edit-render="{}">
							<template v-slot:edit="scope">
								<el-input :disabled="true" placeholder="请填写创建时间" v-model="scope.row.createTime"/>
							</template>
						</vxe-table-column>
						<vxe-table-column title="操作" align="center" width="100">
							<template v-slot="scope">
								<el-button :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'base')">删除</el-button>
							</template>
						</vxe-table-column>
					</vxe-table>
				</el-col>
			</el-row>

			<el-divider content-position="left"><i class="el-icon-document"></i>
				基本信息
			</el-divider>
			<el-row  :gutter="15">
				<el-col :span="12">
					<el-form-item label="用车人员" prop="useMen"
								  :rules="[ {required: true, message:'用车人员不能为空', trigger:'blur'}]">
						<UserSelectSignatory style="width: 100%" ref="userSelect2"
											 :readonly="true" :modelValue="inputForm.useMen"
											 @update:modelValue='(value) => {inputForm.useMen = value}'></UserSelectSignatory>					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="用车起止时间" prop="useDate"
								  :rules="[
								  {required: true, message:'用车起止时间不能为空', trigger:'blur'}]">
						<el-date-picker
							:disabled-date="getDisabledData"
							v-model="inputForm.useDate"
							type="daterange"
							start-placeholder="请选择开始时间"
							end-placeholder="请选择结束时间"
							value-format="YYYY-MM-DD HH:mm:ss"
							time-format="HH"
						/>
					</el-form-item>
				</el-col>
				<el-col :span="24">
					<el-form-item label="用车原因" prop="useReason"
								  :rules="[ {required: true, message:'用车原因不能为空', trigger:'blur'}]">
						<el-input :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" type="textarea" placeholder="请输入说明"  maxlength="500"  style="width:100%" v-model="inputForm.useReason" show-word-limit></el-input>
					</el-form-item>
				</el-col>



				<el-col :span="24">
					<el-form-item label="备注" prop="remarks"
								  :rules="[ ]">
						<el-input :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" type="textarea" placeholder="请输入说明"  maxlength="500"  style="width:100%" v-model="inputForm.remarks" show-word-limit></el-input>
					</el-form-item>
				</el-col>
			</el-row>
		</el-form>
		<ProjectForm ref="projectForm" @getProgram="getProgram"></ProjectForm>
		<UpLoadComponent ref="uploadComponent"></UpLoadComponent>

	</div>
</template>

<script>
	import XEUtils from 'xe-utils'
	import DriveService from '@/api/jy/DriveService'
	import { ElDatePicker } from 'element-plus';
	import ProjectForm from './ProjectForm'
	import UserSelectSignatory from './clientUserSelect'
	import UpLoadComponent from '@/views/common/UpLoadComponent'
	import CommonApi from '@/api/cw/common/CommonApi'
	import moment from "moment";
	export default {
		props: {
			businessId: {
				type: String,
				default: ''
			},
			formReadOnly: {
				type: Boolean,
				default: false
			},
			status: {
				type: String,
				default: ''
			}
		},
		data () {
			return {
				title: '',
				method: '',
				loading: false,
				inputForm: {
					id: '',
					useMen:'',
					useReason: '',
					useStartTime:'',
					useEndTime:'',
					remarks: '',
					projectList:[],
					files: [], // 附件信息
					procInsId: '',
					useDate:[],
				},
				baseKey: '',
				keyWatch: '',
				dateList:[],
				programRow:'',
				disabledDates:[],

			}
		},
		DriveService:null,
		commonApi: null,
		created () {
			this.driveService=new DriveService()
			this.commonApi = new CommonApi()
		},
		mounted () {
		},
		activated () {
		},
		components: {
			ElDatePicker,
			ProjectForm,
			UserSelectSignatory,
			UpLoadComponent,
		},
		computed: {
			bus: {
				get () {
					this.$refs.uploadComponent.setDividerName('附件')
					return this.businessId
				},
				set (val) {
					this.businessId = val
				}
			}
		},
		watch: {
			'keyWatch': {
				handler (newVal) {
					if (this.commonJS.isNotEmpty(this.bus)) {
						this.init('', this.bus)
					} else {
						this.$nextTick(() => {
							this.$refs.inputForm.resetFields()
						})
					}
				}
			},
			'loading': {
				handler (newVal) {
					this.$emit('changeLoading', newVal)
					this.$refs.uploadComponent.changeLoading(newVal)
				}
			}
		},
		methods: {
			getKeyWatch(keyWatch) {
				this.keyWatch = keyWatch
			},
			init(method, id) {
				this.method = method
				this.inputForm={
					id: '',
					useMen:'',
					useReason: '',
					useDate:[],
					remarks: '',
					projectList:[],
					files: [], // 附件信息
					procInsId: '',
				}
				this.inputForm.id = id
				this.loading = false
				this.$nextTick(() => {
					this.$refs.inputForm.resetFields()
					this.loading = true
					this.$refs.uploadComponent.clearUpload()
					this.driveService.queryById(this.inputForm.id).then((data)=>{
						this.inputForm = this.recover(this.inputForm, data)
						this.inputForm.files=data.files
						console.log('s',this.inputForm)
						if (this.status === 'audit' || this.status === 'taskFormDetail') {
							method = 'view'
						}
						if (this.commonJS.isEmpty(this.inputForm.projectList)) {
							this.inputForm.projectList=[]
						}
						console.log('me',method)
						this.$refs.uploadComponent.newUpload(method, this.inputForm.files, 'driveApply',null,null,null,null,null)
						this.loading = false
					})
					this.driveService.getUserTime().then((data)=>{
						this.disabledDates = data
					})
				})
			},
			saveForm(callback) {
				this.doSubmit('save', callback)
			},
			startForm(callback) {
				this.loading = true
				if (this.commonJS.isNotEmpty(this.inputForm.id)) {
					this.driveService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '0' && data.status !== '1' && data.status !== '3') { // 审核状态不是“未发起”或“暂存”或“撤回”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							this.doSubmit('start', callback)
						}
					})
				} else {
					this.doSubmit('start', callback)
				}
			},
			async agreeForm(callback) {
				console.log('进入方法')
				this.loading = true
				await this.driveService.queryById(this.inputForm.id).then((data) => {
					if (data.status !== '2' ) { // status的值不等于“审核中”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error()
					} else {
						this.inputForm.status= '2'
						this.commonApi.getTaskNameByProcInsId(this.inputForm.procInsId).then((data)=>{
							if (this.commonJS.isNotEmpty(data)) {
								if (data === '总经理审核') {
									this.inputForm.status = '5'
								}
							}
							let param = {status: this.inputForm.status, id: this.inputForm.id}
							this.inputForm=JSON.stringify(this.inputForm)
							this.driveService.updateStatusById(param).then(() => {
								callback(data.businessTable, data.businessId, this.inputForm)
								this.loading = false
							}).catch(() => {
								this.loading = false
							})
						})
					}
				})
			},
			reapplyForm(callback) {
				this.loading = true
				this.driveService.queryById(this.inputForm.id).then((data) => {
					if (data.status !== '4') { // 审核状态不是“驳回”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.doSubmit('reapply', callback)
					}
				})
			},
			// 表单提交
			async doSubmit(status, callback) {
				this.loading = true
				console.log('5',this.inputForm)
				if (status === 'save') {
					// 暂存
					this.loading = true
					this.inputForm.status = '1'
					if (this.inputForm.useDate !== undefined ||this.inputForm.useDate !== null || this.inputForm.useDate.length !== 0){
						this.inputForm.useStartTime=this.inputForm.useDate[0]
						this.inputForm.useEndTime=this.inputForm.useDate[1]
					}
					if (this.$refs.uploadComponent.checkProgress()) {
						this.loading = false
						return
					}
					this.inputForm.files = this.$refs.uploadComponent.getDataList()
					this.driveService.saveForm(this.inputForm).then((data) => {
						callback(data.businessTable, data.businessId, this.inputForm)
						this.loading = false
					}).catch(() => {
						this.loading = false
					})
					return
				} else if (status === 'start') {

					this.inputForm.files = this.$refs.uploadComponent.getDataList()
					// 送审  待审核
					this.inputForm.status = '2'
				} else if (status === 'agree') {
					this.inputForm.status= '5'
				} else if (status === 'reapply') {
					this.inputForm.status = '2'
				}
				this.$refs['inputForm'].validate((valid) => {
					if (valid) {
						this.loading = true
						if (this.commonJS.isEmpty(this.inputForm.projectList)) {
							this.loading = false
							this.$message.error('请选择用车项目')
							throw new Error()
						}
						if (this.inputForm.useDate == undefined ||this.inputForm.useDate == null || this.inputForm.useDate.length <= 0 ) {
							this.$message.error('请选择用车时间')
							this.loading = false
						}
						if (this.commonJS.isEmpty(this.inputForm.useMen)){
							this.$message.error('请选择用车人员')
							this.loading = false
						}
						if (this.commonJS.isEmpty(this.inputForm.useReason)){
							this.$message.error('请选择用车原因')
							this.loading = false
						}

						if (this.$refs.uploadComponent.checkProgress()) {
							this.loading = false
							return
						}
						this.inputForm.useStartTime=this.inputForm.useDate[0]
						this.inputForm.useEndTime=this.inputForm.useDate[1]
						console.log('form',this.inputForm)
						if (this.commonJS.isNotEmpty(this.inputForm.useStartTime) && this.commonJS.isNotEmpty(this.inputForm.useEndTime)){
							this.driveService.checkTimeRange(this.inputForm.useStartTime,this.inputForm.useEndTime).then((data)=>{
								if (data){
									this.loading = false
									this.$message.error('用车时间存在重叠,请重新选择时间')
									throw new Error()
								}else {
									if (this.commonJS.isNotEmpty(this.inputForm.useMen)) {
										this.driveService.checkUseMen(this.inputForm.useMen).then((data) => {
											if (data === false) {
												this.$message.error('只能选择本部门员工')
												this.loading = false
												return
											}
											this.driveService.saveForm(this.inputForm).then((data) => {
												callback(data.businessTable, data.businessId, this.inputForm)
												this.$refs.inputForm.resetFields()
												this.loading = false
											}).catch(() => {
												this.$refs.inputForm.resetFields()
												this.loading = false
											})
										})
									}
								}
							})
						}
					} else {
						this.loading = false
					}
				})
			},
			close() {
				this.inputForm = {
					id:'',
					projectList:[],
					name:'',
					no:'',
					projectLeader:'',
					projectCreateDate:'',
					createById:'',
					createByName:'',
					createDate:'',
					remarks:'',
					files: [], // 附件信息
					types:[], //用印类型
					number:'', //用印份数
					projectId:'',
				}
				this.visible = false
			},
			async updateStatusById(type, callback) {
				this.loading = true
				if (type === 'reject' || type === 'reback') {
					this.driveService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '2') { // status的值不等于“审核中”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// if (type === 'agree') {
							//   // 同意
							//   this.inputForm.status = '5'
							// }
							if (type === 'reject') {
								// 驳回
								this.inputForm.status = '4'
							}
							if (type === 'reback') {
								// 撤回
								this.inputForm.status = '3'
							}
							if (type === 'reject' || type === 'reback') {
								let param = {status: this.inputForm.status, id: this.inputForm.id}
								this.driveService.updateStatusById(param).then(() => {
									this.loading = false
									callback()
								})
							}
						}
					})
				} else if (type === 'hold') {
					this.driveService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '4') { // status的值不等于“驳回”就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// 终止
							let param = {status: '1', id: this.inputForm.id}
							this.driveService.updateStatusById(param).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				}

			},
			insertEvent(type) {
				if (type === 'base') {
					if (this.inputForm.projectList.length>=1){
						if (this.commonJS.isEmpty(this.inputForm.projectList[0].projectId)){
							this.$message.error('第一行不能为空')
							return
						}
					}
					this.$refs.baseTable.insertAt({})
					this.inputForm.projectList.push({})
					this.baseKey = Math.random()
				}
				console.log('22',this.inputForm.projectList)
			},
			// 删除
			removeEvent(row, rowIndex, type) {
				if (type === 'base') {
					this.$refs.baseTable.remove(row)
					this.inputForm.projectList.splice(rowIndex, 1)
				}
			},
			openProgramPageForm(rowIndex) {
				this.$refs.projectForm.init('2',true)
				this.programRow = rowIndex
				console.log('11',this.programRow)
			},
			getProgram(rows) {
				console.log('1',rows)
				rows.forEach((item, index) => {
					this.inputForm.programId = item.id
					if (index === 0) {
						let r = this.inputForm.projectList[this.programRow]
						r.projectId=item.id
						r.name = item.name
						r.no = item.no
						r.leader = item.projectLeader
						r.createTime = item.createTime
						console.log('2',this.inputForm.projectList[this.programRow])
					} else {
						let r = {
							projectId: item.id,
							name: item.name,
							no: item.no,
							leader: item.projectLeader,
							createTime: item.createTime,
						}
						this.$refs.baseTable.insertAt(r)
						this.inputForm.projectList.push(r)
						this.baseKey = Math.random()
					}

				})
				this.$forceUpdate()
				this.programRow = ''
				// this.inputForm.reconciliationArea = this.inputForm.financeInvoiceBaseDTOList[0].location
			},
			//获取需要禁用时间
			getDisabledData(time) {

				// if (time.getTime() < Date.now() - 24 * 3600 * 1000){
				// 	return true
				// }
				// 检查给定的时间是否在禁用时间范围内
				for (let i = 0; i < this.disabledDates.length; i++) {
					const startTime = moment(this.disabledDates[i].startTime).startOf('day');
					const endTime = moment(this.disabledDates[i].endTime).endOf('day');
					const timeMoment = moment(time);
					console.log('startTime',startTime.valueOf())
					console.log('endTime',endTime.valueOf())
					console.log('time.getTime()',time.getTime())
					if (timeMoment.isBetween(startTime, endTime, null, '[]') || time.getTime() < Date.now() - 24 * 3600 * 1000) {
						return true; // 如果在给定的禁用时间范围内，返回 true
					}
				}

				// 如果没有在禁用时间范围内，则检查是否在过去（不包括今天）
				return false;
			},

			//校验时间
			checkTimeRange(){
				this.loading = true
				this.inputForm.useStartTime=this.inputForm.useDate[0]
				this.inputForm.useEndTime=this.inputForm.useDate[1]
				this.driveService.checkTimeRange(this.inputForm.useStartTime,this.inputForm.useEndTime).then((data)=>{
					this.loading = false
					this.$message.error(data)
					return
				})
			}



		}

	}
</script>
<style scoped>
	/deep/ .el-input-number .el-input__inner {
		text-align: left;
	}
	/deep/ .vxe-footer--row .vxe-footer--column:nth-child(1) .vxe-cell--item {
		font-weight:700;
	}
</style>
